<?xml version="1.0"?>
<!--
	The lestes compiler suite
	Copyright (C) 2002, 2003, 2004, 2005 Miroslav Tichy
	Copyright (C) 2002, 2003, 2004, 2005 Petr Zika
	Copyright (C) 2002, 2003, 2004, 2005 Vojtech Hala
	Copyright (C) 2002, 2003, 2004, 2005 Jiri Kosina
	Copyright (C) 2002, 2003, 2004, 2005 Pavel Sanda
	Copyright (C) 2002, 2003, 2004, 2005 Jan Zouhar
	Copyright (C) 2002, 2003, 2004, 2005 Rudolf Thomas

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; version 2 of the License.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	See the full text of the GNU General Public License version 2, and
	the limitations in the file doc/LICENSE.

	By accepting the license the licensee waives any and all claims
	against the copyright holder(s) related in whole or in part to the
	work, its use, and/or the inability to use it.
-->
<!DOCTYPE xsl:transform [
<!ENTITY nl "&#x0A;">
<!ENTITY tab "&#x09;">
]>
<xsl:transform version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:lsd="http://lestes.jikos.cz/schemas/lsd">
	<!-- Generate C++ implementation for data structures from XML description. -->
	<xsl:output method="text" encoding="ISO-8859-1"/>

	<xsl:template match="lsd:lsd">
		<xsl:text>// This file is automatically generated, do not edit.&nl;</xsl:text>
		<xsl:for-each select="//lsd:comment" /> <!-- ignore comments  -->


		<xsl:for-each select="lsd:dox[ @file!='hh']">	<!-- doxygen info about output file -->
			<xsl:text>&nl;/*!&nl;&tab;\file&nl;</xsl:text>
			<xsl:if test="string-length(lsd:bri)">
				<xsl:text>&tab;\brief </xsl:text>
				<xsl:value-of select="lsd:bri"/>
				<xsl:text>&nl;</xsl:text>
			</xsl:if>
			<xsl:if test="string-length(lsd:det)">
				<xsl:text>&tab;</xsl:text>
				<xsl:apply-templates mode="html-text" select="lsd:det/node()"/>
				<xsl:text>&nl;</xsl:text>
			</xsl:if>
			<xsl:text>*/&nl;</xsl:text>
		</xsl:for-each>
		<xsl:text>&nl;</xsl:text>

		<xsl:call-template name="implementation-imports" />
		<xsl:text>#include &lt;lestes/std/list.hh&gt;&nl;</xsl:text>
		<xsl:text>#include &lt;lestes/std/pair.hh&gt;&nl;</xsl:text>
		<xsl:text>#include &lt;lestes/std/reflect.hh&gt;&nl;</xsl:text>
		<xsl:text>&nl;#include &lt;</xsl:text>
		<xsl:for-each select="/lsd:lsd/lsd:packages/lsd:p">
			<xsl:value-of select="concat(text(),'/')" />
		</xsl:for-each>
		<xsl:value-of select="concat(lsd:file-name,'.g.hh&gt;&nl;&nl;')"/>

		<xsl:call-template name="open-packages" />

		<xsl:if test="lsd:cc-header/text() != ''">
			<xsl:value-of select="concat('&nl;',lsd:cc-header,'&nl;&nl;')"/>	<!-- output file prolog -->
		</xsl:if>

		<xsl:for-each select="lsd:class">
			<xsl:variable name="this-class-name" select="@name"/>

			<xsl:text>&nl;// ------------- Class </xsl:text>
			<xsl:value-of select="@name"/>
			<xsl:text> follows. -------------&nl;&nl;</xsl:text>

			<!-- for each field and collection generate its get(), set() methods -->
			<xsl:apply-templates select="lsd:field | lsd:collection" mode="get-set">
				<xsl:with-param name="this-class-name" select="$this-class-name"/>
			</xsl:apply-templates>
			<!-- end of getters and setters -->


			<!-- visitors follow -->
			<xsl:if test="string(@abstract) != 'yes'">
				<xsl:apply-templates mode="accept-bodies" select=".">
					<xsl:with-param name="this-class-name" select="@name"/>
				</xsl:apply-templates>
			</xsl:if>
			<!-- end of visitors -->

			<!-- Factory method(s) follow. -->
			<xsl:if test="(string(@abstract) != 'yes') and (string(@create) = '') and (count(lsd:singleton)=0)">
				<!-- abstract classes do not have factory method (may not be instantiated) -->
				<xsl:text>/*!&nl;   This factory method for class </xsl:text>
				<xsl:value-of select="@name"/>
				<xsl:text> takes values of all fields as arguments.&nl;</xsl:text>
				<xsl:text>   \author lsg&nl; */&nl;</xsl:text>
				<xsl:value-of select="concat('ptr&lt; ',@name,' &gt; ')"/>
				<xsl:value-of select="concat(@name,'::create(')"/>
				<xsl:apply-templates mode="ctor-args" select=".">
					<xsl:with-param name="with-types" select="'yes'"/>
				</xsl:apply-templates>
				<xsl:text>)&nl;{&nl;</xsl:text>
				<!-- first factory method body -->
				<xsl:value-of select="concat('&tab;return ptr&lt; ',@name)"/>
				<xsl:value-of select="concat(' &gt; ( new ',@name,'(')"/>
				<xsl:apply-templates mode="ctor-args" select=".">
					<xsl:with-param name="with-types" select="'no'"/>
				</xsl:apply-templates>
				<xsl:text>) );&nl;</xsl:text>
				<xsl:text>}&nl;&nl;</xsl:text>
				<!-- End of first factory method -->

				<!-- Second factory method follow (if different from previous) -->
				<xsl:variable name="is-init">
					<xsl:apply-templates mode="check-init" select="."/>
				</xsl:variable>
				<xsl:if test="$is-init != ''">
					<xsl:text>/*!&nl;   This factory method for class </xsl:text>
					<xsl:value-of select="@name"/>
					<xsl:text> uses initializers.&nl;</xsl:text>
					<xsl:text>   \author lsg&nl; */&nl;</xsl:text>
					<xsl:value-of select="concat('ptr&lt; ',@name,' &gt; ',@name,'::create(')"/>
					<xsl:apply-templates mode="fact-args" select=".">
						<xsl:with-param name="with-types" select="'yes'"/>
					</xsl:apply-templates>
					<xsl:value-of select="concat(')&nl;{&nl;&tab;return ptr&lt; ',@name)"/>
					<xsl:value-of select="concat(' &gt; ( new ',@name,'(')"/>
					<xsl:apply-templates mode="fact-init" select="."/>
					<xsl:text>) );&nl;}&nl;&nl;</xsl:text>
				</xsl:if>
			</xsl:if>
			<!-- End of second factory method -->

			<!-- the_instance field and instance() method follow -->
			<xsl:if test="count(lsd:singleton)!=0 and string(@instance)!='special'">
				<xsl:text>/*!&nl;   Static field </xsl:text>
				<xsl:value-of select="@name"/>
				<xsl:text>::the_instance.&nl;   \author lsg&nl; */&nl;</xsl:text>
				<xsl:value-of select="concat('ptr&lt; ',@name,' &gt; ',@name,'::the_instance = the_instance;&nl;&nl;')" />
				<xsl:text>/*!&nl;   Generated instance() method for singleton class </xsl:text>
				<xsl:value-of select="@name"/>
				<xsl:text>.&nl;   \author lsg&nl; */&nl;</xsl:text>
				<xsl:value-of select="concat('ptr&lt; ',@name,' &gt; ',@name,'::instance()&nl;{&nl;&tab;')"/>
				<xsl:text> return the_instance ? the_instance : the_instance = </xsl:text>
				<xsl:value-of select="concat('new ',@name,'(')"/>
					<xsl:apply-templates mode="fact-init" select="."/>
				<xsl:text>);&nl;}&nl;&nl;</xsl:text>
			</xsl:if>

			<!-- Constructor follows. -->	    
			<xsl:text>/*!&nl;   Generated constructor for class </xsl:text>
			<xsl:value-of select="@name"/>
			<xsl:text>.&nl;   \author lsg&nl; */&nl;</xsl:text>
			<xsl:value-of select="concat(@name,'::',@name,' (')"/>
			<xsl:apply-templates mode="ctor-args" select=".">
				<xsl:with-param name="with-types" select="'yes'"/>
			</xsl:apply-templates>
			<xsl:text>)&nl;&tab;: </xsl:text>
			<xsl:apply-templates select="." mode="ctor-init"/> <!-- initializer -->
			<xsl:text>&nl;{}&nl;</xsl:text>
			<!-- end of constructor -->

			<!-- two dumping routines follow -->
			<xsl:text>&nl;</xsl:text>
			<xsl:value-of select="concat('ptr&lt; object::reflection_list &gt; ',@name,'::reflection_get() const&nl;{&nl;')"/>
			<xsl:text>&tab;if (!reflection) {&nl;</xsl:text>
			<xsl:text>&tab;&tab;typedef class_reflection::field_metadata md;&nl;</xsl:text>
			<xsl:text>&tab;&tab;typedef class_reflection::field_metadata_list mdlist;&nl;</xsl:text>
			<xsl:text>&tab;&tab;ptr&lt;mdlist&gt; mdl = mdlist::create();&nl;</xsl:text>
			<xsl:apply-templates mode="metadata" select="lsd:field|lsd:collection"/>
			<xsl:text>&tab;&tab;reflection = reflection_list::create( </xsl:text>
			<xsl:call-template name="resolve-base"/>
			<xsl:text>::reflection_get() );&nl;</xsl:text>
			<xsl:text>&tab;&tab;reflection-&gt;push_back( class_reflection::create( &quot;</xsl:text>
			<xsl:value-of select="@name"/>
			<xsl:text>&quot;, mdl ) );&nl;</xsl:text>
			<xsl:text>&tab;}&nl;&tab;return reflection;&nl;}&nl;&nl;</xsl:text>
			<!-- end of reflection_get() -->
			<xsl:value-of select="concat('ptr&lt; object::field_list_list &gt; ',@name,'::field_values_get() const&nl;{&nl;')"/>
			<xsl:text>&tab;ptr &lt; field_list_list &gt; result = </xsl:text>
			<xsl:call-template name="resolve-base"/>
			<xsl:text>::field_values_get();&nl;</xsl:text>
			<xsl:for-each select="lsd:field | lsd:collection">
				<xsl:text>&tab;result-&gt;push_back( value_list::create() );&nl;</xsl:text>
				<xsl:text>&tab;result-&gt;back()-&gt;push_back( </xsl:text>
				<xsl:choose>
					<xsl:when test="(local-name() = 'collection') or key('any-class',@type)">
						<xsl:value-of select="concat('this-&gt;',@name)"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="concat('objectize&lt; ',@type,' &gt; ::create( this-&gt;',@name,' )')"/>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:text> );&nl;</xsl:text>
			</xsl:for-each>
			<xsl:text>&tab;return result;&nl;}&nl;&nl;</xsl:text>
			<!-- end of dumping routines -->

			<!-- "visit-return" methods -->
			<xsl:apply-templates mode="visit-return-body" select="lsd:visit-return-method" />

			<!-- Marking routine follows. -->
			<xsl:text>&nl;/*!&nl;   Marking routine is used for garbage collection.&nl;</xsl:text>
			<xsl:text>   \author lsg&nl; */&nl;</xsl:text>
			<xsl:value-of select="concat('void ',@name,'::gc_mark()&nl;{&nl;&tab;')"/>
			<xsl:for-each select="lsd:field[ key('any-class',@type) and (@specifier!='static') ] | lsd:collection[ @specifier!='static' ]">
				<xsl:value-of select="concat(@name,'.gc_mark();&nl;&tab;')"/>
			</xsl:for-each>
			<xsl:call-template name="resolve-base"/>
			<xsl:text>::gc_mark();</xsl:text>
			<xsl:text>&nl;}&nl;</xsl:text>
			<!-- end of gc_mark -->

			<xsl:text>&nl;// End of class </xsl:text>
			<xsl:value-of select="@name"/>
			<xsl:text>.&nl;</xsl:text>

		</xsl:for-each>
		<!-- End of classes list. -->

		<xsl:text>&nl;&nl;// static data members follow &nl;</xsl:text>
		<xsl:for-each select="lsd:class">
			<xsl:variable name="this-class-name" select="string(@name)"/>
			<xsl:for-each select="lsd:field[ string(@specifier) = 'static' ]">
				<xsl:call-template name="val-or-ptr">
					<xsl:with-param name="data-type" select="@type"/>
				</xsl:call-template>
				<xsl:value-of select="concat(' ',$this-class-name,'::',@name,' = ')"/>
				<xsl:choose>
					<xsl:when test="(string(@init) != 'void') and (count(@init)!=0)">
						<xsl:value-of select="string(@init)"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="@name"/>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:text>;&nl;</xsl:text>
			</xsl:for-each>
			<xsl:for-each select="lsd:collection[ string(@specifier) = 'static' ]">
				<xsl:call-template name="col-ptr"/>
				<xsl:value-of select="concat(' ',$this-class-name,'::',@name,' = ')"/>
				<xsl:choose>
					<xsl:when test="(string(@init) != 'void') and (count(@init)!=0)">
						<xsl:value-of select="string(@init)"/>
						<xsl:if test="string(@init) = ''">
							<xsl:call-template name="col-type"/>
							<xsl:text> ::create()</xsl:text>
						</xsl:if>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="@name"/>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:text>;&nl;</xsl:text>
			</xsl:for-each>
			<xsl:value-of select="concat('ptr&lt;object::reflection_list&gt; ',@name,'::reflection = reflection;&nl;')"/>
		</xsl:for-each>
		<xsl:text>&nl;</xsl:text>

		<xsl:if test="lsd:cc-footer/text() != ''">
			<xsl:value-of select="concat('&nl;',lsd:cc-footer,'&nl;')"/>		<!-- output file epilog -->
		</xsl:if>

		<xsl:call-template name="close-packages"/>

	</xsl:template>
	<!-- end of root element template -->


	<xsl:template match="lsd:field" mode="get-set">
		<xsl:param name="this-class-name"/>
		<xsl:if test="not(@get = 'none') and not(@get = 'special')">
			<xsl:text>/*!&nl;   \returns The value of </xsl:text>
			<xsl:value-of select="concat($this-class-name,'::',@name)"/>
			<xsl:text>.&nl;   \author lsg&nl; */&nl;</xsl:text>
			<xsl:call-template name="val-or-ptr-or-enum">
				<xsl:with-param name="data-type" select="@type"/>
				<xsl:with-param name="class-name" select="$this-class-name"/>
			</xsl:call-template>
			<xsl:value-of select="concat(' ',$this-class-name,'::',@name,'_get()')"/>
			<xsl:if test="string(@specifier) != 'static'">
				<xsl:text> const</xsl:text>
			</xsl:if>
			<xsl:text>&nl;{&nl;&tab;</xsl:text>
			<xsl:value-of select="concat('return ',@name,';&nl;')"/>
			<xsl:text>}&nl;&nl;</xsl:text>
		</xsl:if>
		<!-- end of get() -->
		<xsl:if test="not(@set = 'none') and not(@set = 'special')">
			<xsl:text>/*!&nl;   \param[in] x</xsl:text>
			<xsl:text> The new value to set </xsl:text>
			<xsl:value-of select="concat($this-class-name,'::',@name)"/>
			<xsl:text> to.&nl;   \author lsg&nl; */&nl;</xsl:text>
			<xsl:text>void </xsl:text>
			<xsl:value-of select="concat($this-class-name,'::',@name)"/>
			<xsl:text>_set(</xsl:text>
			<xsl:call-template name="val-or-const-ptr-ref">
				<xsl:with-param name="data-type" select="@type"/>
			</xsl:call-template>
			<xsl:text> x)&nl;{&nl;&tab;</xsl:text>
			<xsl:value-of select="concat($this-class-name,'::',@name,' = x;&nl;')"/>
			<xsl:text>}&nl;&nl;</xsl:text>
		</xsl:if>
		<!-- end of set() -->
		<!--xsl:if test="not(@alt = 'none') and not(@alt = 'special')">
			<xsl:text>/*!&nl;   \param[in] x</xsl:text>
			<xsl:text> The new value to set </xsl:text>
			<xsl:value-of select="concat($this-class-name,'::',@name)"/>
			<xsl:text> to.&nl;   \returns New value of </xsl:text>
			<xsl:value-of select="concat($this-class-name,'::',@name)"/>
			<xsl:text>.&nl;   \author lsg&nl; */&nl;</xsl:text>
			<xsl:call-template name="val-or-ptr-or-enum">
				<xsl:with-param name="data-type" select="@type"/>
				<xsl:with-param name="class-name" select="$this-class-name"/>
			</xsl:call-template>
			<xsl:value-of select="concat(' ',$this-class-name,'::',@name)"/>
			<xsl:text>_alt(</xsl:text>
			<xsl:call-template name="val-or-const-ptr-ref">
				<xsl:with-param name="data-type" select="@type"/>
			</xsl:call-template>
			<xsl:text> x)&nl;{&nl;&tab;</xsl:text>
			<xsl:value-of select="concat('return ',$this-class-name,'::',@name,' = x;&nl;')"/>
			<xsl:text>}&nl;&nl;</xsl:text>
		</xsl:if-->
		<!-- end of alt() -->
	</xsl:template>

	<xsl:template match="lsd:collection" mode="get-set">
		<xsl:param name="this-class-name"/>
		<xsl:if test="not(@get = 'none') and not(@get = 'special')">
			<xsl:text>/*!&nl;   \returns The value of </xsl:text>
			<xsl:value-of select="concat($this-class-name,'::',@name)"/>
			<xsl:text>.&nl;   \author lsg&nl; */&nl;</xsl:text>
			<xsl:call-template name="col-ptr"/>
			<xsl:value-of select="concat(' ',$this-class-name,'::',@name,'_get()')"/>
			<xsl:if test="string(@specifier) != 'static'">
				<xsl:text> const</xsl:text>
			</xsl:if>
			<xsl:text>&nl;{&nl;&tab;</xsl:text>
			<xsl:value-of select="concat('return ',@name,';&nl;')"/>
			<xsl:text>}&nl;&nl;</xsl:text>
		</xsl:if>
		<!-- end of get() -->
		<xsl:if test="not(@set = 'none') and not(@set = 'special')">
			<xsl:text>/*!&nl;   \param[in] x</xsl:text>
			<xsl:text> The new value to set </xsl:text>
			<xsl:value-of select="concat($this-class-name,'::',@name)"/>
			<xsl:text> to.&nl;   \author lsg&nl; */&nl;</xsl:text>
			<xsl:text>void </xsl:text>
			<xsl:value-of select="concat($this-class-name,'::',@name)"/>
			<xsl:text>_set(const </xsl:text>
			<xsl:call-template name="col-ptr"/>
			<xsl:text> &amp; x)&nl;{&nl;&tab;</xsl:text>
			<xsl:value-of select="concat($this-class-name,'::',@name,' = x;&nl;')"/>
			<xsl:text>}&nl;&nl;</xsl:text>
		</xsl:if>
		<!-- end of set() -->
		<!--xsl:if test="not(@alt = 'none') and not(@alt = 'special')">
			<xsl:text>/*!&nl;   \param[in] x</xsl:text>
			<xsl:text> The new value to set </xsl:text>
			<xsl:value-of select="concat($this-class-name,'::',@name)"/>
			<xsl:text> to.&nl;   \returns New value of </xsl:text>
			<xsl:value-of select="concat($this-class-name,'::',@name)"/>
			<xsl:text>.&nl;   \author lsg&nl; */&nl;</xsl:text>
			<xsl:call-template name="col-ptr"/>
			<xsl:value-of select="concat(' ',$this-class-name,'::',@name)"/>
			<xsl:text>_alt(</xsl:text>
			<xsl:call-template name="col-ptr"/>
			<xsl:text> &amp; x)&nl;{&nl;&tab;</xsl:text>
			<xsl:value-of select="concat('return ',$this-class-name,'::',@name,' = x;&nl;')"/>
			<xsl:text>}&nl;&nl;</xsl:text>
		</xsl:if-->
	</xsl:template>

	<xsl:template mode="accept-bodies" match="lsd:class">
		<xsl:param name="this-class-name"/>
		<xsl:for-each select="lsd:visitor">	<!-- my visitors -->
			<xsl:call-template name="val-or-ptr">
				<xsl:with-param name="data-type" select="@type"/>
			</xsl:call-template>
			<xsl:value-of select="concat(' ',$this-class-name,'::accept_',@name,'( ptr&lt; ',@name,' &gt; v )&nl;')"/>
			<xsl:text>{&nl;&tab;return v-&gt;visit_</xsl:text>
			<xsl:value-of select="concat($this-class-name,'( this );&nl;}&nl;&nl;')"/>
		</xsl:for-each>
		<xsl:variable name="base-class-name">
			<xsl:call-template name="resolve-base"/>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="document('',.)/lsd:lsd/lsd:class[@name = $base-class-name]">
				<xsl:apply-templates mode="accept-bodies" select="document('',.)/lsd:lsd/lsd:class[@name = $base-class-name]">
					<xsl:with-param name="this-class-name" select="$this-class-name"/>
				</xsl:apply-templates>
			</xsl:when>
			<xsl:otherwise>
				<xsl:variable name="doc">
					<xsl:call-template name="class-lookup">
						<xsl:with-param name="class" select="$base-class-name"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:if test="string-length($doc) != 0">
					<xsl:apply-templates mode="accept-bodies" select="document($doc,.)/lsd:lsd/lsd:class[@name = $base-class-name]">
						<xsl:with-param name="this-class-name" select="$this-class-name"/>
					</xsl:apply-templates>
				</xsl:if>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template mode="metadata" match="lsd:field">
		<xsl:value-of select="concat('&tab;&tab;mdl-&gt;push_back( md::create( &quot;',@name,'&quot;, &quot;')"/>
		<xsl:call-template name="xml-special-chars">
			<xsl:with-param name="input" select="@type"/>
		</xsl:call-template>
		<xsl:text>&quot; ) );&nl;</xsl:text>
	</xsl:template>

	<xsl:template mode="metadata" match="lsd:collection">
		<xsl:value-of select="concat('&tab;&tab;mdl-&gt;push_back( md::create( &quot;',@name,'&quot;, &quot;')"/>
		<xsl:call-template name="xml-special-chars">
			<xsl:with-param name="input">
				<xsl:call-template name="col-metatype"/>
			</xsl:with-param>
		</xsl:call-template>
		<xsl:text>&quot; ) );&nl;</xsl:text>
	</xsl:template>

	<xsl:template name="xml-special-chars">
		<!-- transform all lower-than and greater-than signs into &lt; and &gt; -->
		<xsl:param name="input"/>
		<xsl:call-template name="translate-lt">
			<xsl:with-param name="input">
				<xsl:call-template name="translate-gt">
					<xsl:with-param name="input" select="$input"/>
				</xsl:call-template>
			</xsl:with-param>
		</xsl:call-template>
	</xsl:template>

	<xsl:template name="translate-lt">
		<!-- recursively substitute all lower-than signs by &lt; -->
		<xsl:param name="input"/>
		<xsl:choose>
			<xsl:when test="contains($input, '&lt;')">
				<xsl:value-of select="substring-before($input, '&lt;')"/>
				<xsl:text>&amp;lt;</xsl:text>
				<xsl:call-template name="translate-lt">
					<xsl:with-param name="input" select="substring-after($input, '&lt;')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$input"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="translate-gt">
		<!-- recursively substitute all greater-than signs by &gt; -->
		<xsl:param name="input"/>
		<xsl:choose>
			<xsl:when test="contains($input, '&gt;')">
				<xsl:value-of select="substring-before($input, '&gt;')"/>
				<xsl:text>&amp;gt;</xsl:text>
				<xsl:call-template name="translate-gt">
					<xsl:with-param name="input" select="substring-after($input, '&gt;')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$input"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template mode="visit-return-body" match="lsd:visit-return-method">
		<xsl:choose>
			<xsl:when test="string-length(@get-from) = 0">
				<xsl:text>void</xsl:text>
			</xsl:when>
			<xsl:otherwise>
				<xsl:apply-templates mode="resolve-field-type" select="..">
					<xsl:with-param name="name" select="@get-from" />
					<xsl:with-param name="type" select="'cc'" />
					<!-- only for error reporting: -->
					<xsl:with-param name="err-class" select="../@name" />
					<xsl:with-param name="err-method" select="@name" />
				</xsl:apply-templates>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:variable name="visitor-name">
			<xsl:apply-templates mode="resolve-base-visitor-name" select=".." />
		</xsl:variable>
		<xsl:if test="string-length($visitor-name) = 0">
			<xsl:message terminate="yes">
				<xsl:value-of select="concat('Could not find name of base visitor when processing visit-return-method named &quot;',@name,'&quot; in class &quot;',../@name,'&quot;.')" />
			</xsl:message>
		</xsl:if>
		<xsl:value-of select="concat(' ',../@name,'::',@name,'( const ptr&lt; ')" />
		<xsl:apply-templates mode="get-class-with-visitor" select="/lsd:lsd">
			<xsl:with-param name="name" select="$visitor-name" />
		</xsl:apply-templates>
		<xsl:text> &gt; &amp; o )&nl;</xsl:text>
		<xsl:text>{&nl;</xsl:text>
		<xsl:text>&tab;lassert2( o, &quot;Cannot visit NULL object.&quot; );&nl;</xsl:text>
		<xsl:value-of select="concat('&tab;o-&gt;accept_',$visitor-name,'( ptr&lt; ',$visitor-name,' &gt;(this) );&nl;')" />
		<xsl:if test="string-length(@get-from) != 0">
			<xsl:value-of select="concat('&tab;return ',@get-from,'_get();&nl;')" />
		</xsl:if>
		<xsl:text>}&nl;&nl;</xsl:text>
	</xsl:template>

	<xsl:include href="common.xslt"/>

</xsl:transform>
